/*
 * Copyright (C) 2000 - NoCrew Productions
 *
 * STsndplay is licensed under the GNU General Public License.
 * For further details read the provided 'License' file.
 *
 */

#include <linux/soundcard.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>

int audio_init(int mode, int bits, int freq, int sout)
{
  int io_format;
  int io_stereo;
  int io_freq;
  int afd;

  if(sout) return 1;

  if(bits != 16)
    return -1;

  io_format = AFMT_S16_BE;
  io_stereo = mode;
  io_freq = freq;

  afd = open("/dev/dsp", O_WRONLY);
  if(afd < 0)
    return -1;
  
  ioctl(afd, SNDCTL_DSP_SPEED, &io_freq);
  ioctl(afd, SNDCTL_DSP_STEREO, &io_stereo);
  ioctl(afd, SNDCTL_DSP_SETFMT, &io_format);

  return afd;
}
