/*
 * Copyright (C) 2000 - NoCrew Productions
 *
 * STsndplay is licensed under the GNU General Public License.
 * For further details read the provided 'License' file.
 *
 */

#include <stdio.h>
#include <ocpuis.h>

#define NGET(size,nsz) \
static __inline__ \
CPU##size GET_##size(CPUaddr addr, void *data, int offset) \
{ \
  int i; \
  unsigned int tmp = 0; \
  \
  for(i=0;i<nsz;i++) { \
    tmp += (*((unsigned char *)((addr - offset + data+i))))<<((nsz-i-1)*8); \
  } \
  \
  return tmp; \
}

#define DGET(size,nsz) \
static __inline__ \
CPU##size GET_##size(CPUaddr addr, void *data, int offset) \
{ \
  int i; \
  unsigned int tmp = 0; \
  \
  for(i=0;i<nsz;i++) { \
    tmp += (*((unsigned char *)(addr - offset+data+i)))<<((nsz-i-1)*8); \
  } \
  fprintf(stderr, "Get " #size " from address 0x%08x (0x%08x)\n", \
          (int)addr+offset, tmp); \
  \
  return tmp; \
}

#define NPUT(size,nsz) \
static __inline__ \
void PUT_##size(CPUaddr addr, void *data, int offset, CPU##size value) \
{ \
  int i; \
  \
  for(i=0;i<nsz;i++) { \
    *((unsigned char *)(addr - offset+data+i)) = \
     (value&(0xff<<((nsz-i-1)*8)))>>((nsz-i-1)*8); \
  } \
}

#define DPUT(size,nsz) \
static __inline__ \
void PUT_##size(CPUaddr addr, void *data, int offset, CPU##size value) \
{ \
  int i; \
  \
  fprintf(stderr, "Put " #size " to address 0x%08x (0x%08x)\n", \
          (int)addr+offset, (unsigned int)value); \
  for(i=0;i<nsz;i++) { \
    *(((unsigned char *)data+offset+i)) = \
     (value&(0xff<<((nsz-i-1)*8)))>>((nsz-i-1)*8); \
  } \
}

#ifdef DEBUG
DGET(byte,1);
DGET(word,2);
DGET(long,4);
DPUT(byte,1);
DPUT(word,2);
DPUT(long,4);
#else
NGET(byte,1);
NGET(word,2);
NGET(long,4);
NPUT(byte,1);
NPUT(word,2);
NPUT(long,4);
#endif

#define GET(size, addr, section) GET_##size(addr, section->data,\
					    section->offset)
#define PUT(size, addr, section, value) PUT_##size(addr, section->data,\
						   section->offset, value)




