/*
 * Copyright (C) 2000 - NoCrew Productions
 *
 * STsndplay is licensed under the GNU General Public License.
 * For further details read the provided 'License' file.
 *
 */

#include <ocpuis.h>
#include <stdlib.h>
#include "mem.h"
#include "common.h"

static MEM *mem;

CPUbyte mem_get_byte(CPUaddr addr)
{
  return GET(byte, addr, mem);
}

CPUword mem_get_word(CPUaddr addr)
{
  return GET(word, addr, mem);
}

CPUlong mem_get_long(CPUaddr addr)
{
  return GET(long, addr, mem);
}

void mem_put_byte(CPUaddr addr, CPUbyte value)
{
  PUT(byte, addr, mem, value);
}

void mem_put_word(CPUaddr addr, CPUword value)
{
  PUT(word, addr, mem, value);
}

void mem_put_long(CPUaddr addr, CPUlong value)
{
  PUT(long, addr, mem, value);
}

void *mem_real_addr(CPUaddr addr)
{
  return (void *)(addr - mem->offset + mem->data);
}

int mem_valid_addr(CPUaddr addr, CPUlong size)
{
  CPUaddr inaddr;
  inaddr = addr - mem->offset;

  if((inaddr < 0) || ((inaddr+size) > mem->size))
    return -1;

  return 0;
}

void mem_init(int size, int offset)
{
  mem = (MEM *)malloc(sizeof(MEM));

  mem->size = size;
  mem->data = malloc(size);
  mem->offset = offset;
}
