/*
 * Copyright (C) 2000 - NoCrew Productions
 *
 * STsndplay is licensed under the GNU General Public License.
 * For further details read the provided 'License' file.
 *
 */

#ifndef _MEMORY_H_
#define _MEMORY_H_

#include <ocpuis.h>

typedef
struct sMEM {
  void *data;
  int offset;
  int size;
} MEM;

CPUbyte mem_get_byte(CPUaddr);
CPUword mem_get_word(CPUaddr);
CPUlong mem_get_long(CPUaddr);
void mem_put_byte(CPUaddr, CPUbyte);
void mem_put_word(CPUaddr, CPUword);
void mem_put_long(CPUaddr, CPUlong);
void *mem_real_addr(CPUaddr);
int mem_valid_addr(CPUaddr, CPUlong);

void mem_init(int, int);

#endif /* _MEMORY_H_ */
