/*
 * Copyright (C) 2000 - NoCrew Productions
 *
 * STsndplay is licensed under the GNU General Public License.
 * For further details read the provided 'License' file.
 *
 */

#ifndef _MFP_H_
#define _MFP_H_

#include <ocpuis.h>

#define MFP_TAVEC (0x134/4)
#define MFP_TBVEC (0x120/4)
#define MFP_TCVEC (0x114/4)
#define MFP_TDVEC (0x110/4)
#define MFP_TA 0
#define MFP_TB 1
#define MFP_TC 2
#define MFP_TD 3

CPUbyte mfp_get_byte(CPUaddr);
CPUword mfp_get_word(CPUaddr);
CPUlong mfp_get_long(CPUaddr);
void mfp_put_byte(CPUaddr, CPUbyte);
void mfp_put_word(CPUaddr, CPUword);
void mfp_put_long(CPUaddr, CPUlong);
void *mfp_real_addr(CPUaddr);
int mfp_valid_addr(CPUaddr, CPUlong);
void mfp_init(void);
int mfp_getcnt(int);
int mfp_subcnt(int, int);
int mfp_addcnt(int, int);
int mfp_setcnt(int, int);
int mfp_timerenable(int);
int mfp_timerpending(int);
int mfp_timerrunning(int);
int mfp_timermasked(int);
double mfp_getfreq(int);
void mfp_resetcnt(int);
void mfp_activate(int, double);
void mfp_mark(int, int);

#endif /* _MFP_H_ */
