/*
 * Copyright (C) 2000 - NoCrew Productions
 *
 * STsndplay is licensed under the GNU General Public License.
 * For further details read the provided 'License' file.
 *
 */

#include <ocpuis.h>
#include <stdlib.h>
#include "vec.h"
#include "common.h"

static VEC *vec;

CPUbyte vec_get_byte(CPUaddr addr)
{
  return GET(byte, addr, vec);
}

CPUword vec_get_word(CPUaddr addr)
{
  return GET(word, addr, vec);
}

CPUlong vec_get_long(CPUaddr addr)
{
  return GET(long, addr, vec);
}

void vec_put_byte(CPUaddr addr, CPUbyte value)
{
  PUT(byte, addr, vec, value);
}

void vec_put_word(CPUaddr addr, CPUword value)
{
  PUT(word, addr, vec, value);
}

void vec_put_long(CPUaddr addr, CPUlong value)
{
  PUT(long, addr, vec, value);
}

void *vec_real_addr(CPUaddr addr)
{
  return (void *)(addr - vec->offset + vec->data);
}

int vec_valid_addr(CPUaddr addr, CPUlong size)
{
  CPUaddr inaddr;
  inaddr = addr - vec->offset;

  if((inaddr < 0) || ((inaddr+size) > vec->size))
    return -1;

  return 0;
}

void vec_init(int size, int offset)
{
  vec = (VEC *)malloc(sizeof(VEC));

  vec->size = size;
  vec->data = malloc(size);
  vec->offset = offset;
}
